#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       paraSnappyHexMeshLayer.py
#
#           snappyHexMeshを並列処理する。（layer作成用）
#           mesh作成後、reconstructParMeshを実行し、結果を再構築する。
#
#   17/03/16    新規作成
#

import sys
import os
import paraSnappyHexMesh


if __name__ == "__main__":
    #引数を取得
    nCpu = sys.argv[1]      #並列数
    x = sys.argv[2]
    y = sys.argv[3]
    z = sys.argv[4]
    nSep = [x,y,z]          #分割方法
    #decomposeParDict作成
    stat = paraSnappyHexMesh.createDecomposeParDict(nCpu, nSep)
    if stat != "OK":
        exit()
    #mesh分割
    stat = paraSnappyHexMesh.decomposePar()
    if stat != "OK":
        exit()
    #snappyを並列処理
    stat = paraSnappyHexMesh.runSnappy(nCpu)
    if stat != "OK":
        exit()
    #meshを再構築
    stat = paraSnappyHexMesh.reconstructMesh()
    if stat != "OK":
        exit()
    #不要なfolderを削除
    comm = "rm -rf ./processor*"
    print comm
    os.system(comm)

