#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#       gridEngineJobControlDialog.py
#
#       岐阜高専vector1用のJob管理
#       jobFileの選択、作成、投入。qsubコマンドは、自動作成する。
#
#   17/07/25    新規作成
#      08/09    setCurrDir:currDirの表示がおかしくなる場合がある為、修正
#
#
# generated by wxGlade 0.6.7+ on Mon Jul  3 10:26:13 2017
#

import wx
import os
import sys
import glob
import subprocess
import pyTreeFoam
import getOpenFileDDialog


# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
# end wxGlade

serverName = u""
caseDir = ""
jobFile = ""
paraEnv = ""
nCpu = ""
selHost = ""
settingFileName = ""
paraEnvs = ["mpi_fu", "mpi_rr"]


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"gridEngine Job管理"))
        self.label_16 = wx.StaticText(self, wx.ID_ANY, _("currDir:"))
        self.label_17 = wx.StaticText(self, wx.ID_ANY, _("label_17"))
        self.label_13 = wx.StaticText(self, wx.ID_ANY, _(u"Jobファイルを選択、作成して、Jobを投入する。\nqsubオプション（並列環境、プロセス数等）は、右画面上で、再設定できる。"))
        self.label_10 = wx.StaticText(self, wx.ID_ANY, _(u"Job File名"))
        self.text_ctrl_4 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"参照..."))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"Job編集"))
        self.static_line_2 = wx.StaticLine(self, wx.ID_ANY, style=wx.LI_VERTICAL)
        self.panel_3 = wx.Panel(self, wx.ID_ANY)
        self.label_5 = wx.StaticText(self.panel_3, wx.ID_ANY, _(u"並列環境:"))
        self.combo_box_1 = wx.ComboBox(self.panel_3, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.panel_1 = wx.Panel(self, wx.ID_ANY)
        self.label_11 = wx.StaticText(self.panel_1, wx.ID_ANY, _("nPs:"))
        self.text_ctrl_1 = wx.TextCtrl(self.panel_1, wx.ID_ANY, "")
        self.label_12 = wx.StaticText(self.panel_1, wx.ID_ANY, _(u"host名:"))
        self.text_ctrl_5 = wx.TextCtrl(self.panel_1, wx.ID_ANY, "")
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"設定file編集"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"設定"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"Job投入実行..."))
        self.static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _(u"ノードの状況確認"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _("qstat -f"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _("ganglia"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"その他コマンド"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_13 = wx.Button(self, wx.ID_ANY, _("run"))
        self.text_ctrl_3 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.sizer_3_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"Job投入"))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, "")
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _(u"投入Job読込・表示"))
        self.button_14 = wx.Button(self, wx.ID_ANY, _("qstat"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"Jobを選択後、クリック"))
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _(u"log表示"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _("tail -f"))
        self.label_15 = wx.StaticText(self, wx.ID_ANY, _(u" 残渣の表示"))
        self.button_16 = wx.Button(self, wx.ID_ANY, _("plotWatcher"))
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"Job停止"))
        self.button_15 = wx.Button(self, wx.ID_ANY, _("qdel"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _("label_2"))
        self.list_box_1 = wx.ListBox(self, wx.ID_ANY, choices=[])
        self.sizer_4_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"Job実行状況の確認"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"folder開く"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"login端末起動"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onSelectJob, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onEditJob, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onEditSettingFile, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onSetQueueCpu, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunJob, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onQstat_f, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onGanglia, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onRunCommand, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.onQstat, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onShowLog, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onPlotWatcher, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.onQdel, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onRunTerminal, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_1)
        # end wxGlade

        self.subInitialize()


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.text_ctrl_4.SetMinSize((140, 28))
        self.button_5.SetMinSize((50, 30))
        self.combo_box_1.SetMinSize((130, 30))
        self.panel_3.SetMinSize((190, 30))
        self.text_ctrl_1.SetMinSize((40, 28))
        self.text_ctrl_5.SetMinSize((50, 28))
        self.panel_1.SetMinSize((190, 30))
        self.button_8.SetMinSize((110, 60))
        self.button_9.SetMinSize((110, 40))
        self.text_ctrl_2.SetMinSize((120, 28))
        self.button_13.SetMinSize((50, 30))
        self.text_ctrl_3.SetMinSize((530, 130))
        # end wxGlade

        self.SetTitle(_(u"Grid Engine Job管理"))

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_26 = wx.BoxSizer(wx.VERTICAL)
        sizer_30 = wx.BoxSizer(wx.VERTICAL)
        sizer_27 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_29 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_34 = wx.BoxSizer(wx.VERTICAL)
        sizer_36 = wx.BoxSizer(wx.VERTICAL)
        sizer_35 = wx.BoxSizer(wx.VERTICAL)
        sizer_28 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_3_staticbox.Lower()
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.VERTICAL)
        sizer_24 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_25 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_22 = wx.BoxSizer(wx.VERTICAL)
        sizer_23 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_20 = wx.BoxSizer(wx.VERTICAL)
        sizer_21 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_42 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_47 = wx.BoxSizer(wx.VERTICAL)
        sizer_48 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_45 = wx.BoxSizer(wx.VERTICAL)
        sizer_46 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_39 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_40 = wx.BoxSizer(wx.VERTICAL)
        sizer_41 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        sizer_31 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_32 = wx.BoxSizer(wx.VERTICAL)
        sizer_33 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_37 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_37.Add(self.label_16, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_37.Add(self.label_17, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(sizer_37, 0, wx.EXPAND, 0)
        sizer_3.Add(self.label_13, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_10.Add(self.label_10, 0, wx.LEFT, 5)
        sizer_33.Add(self.text_ctrl_4, 0, wx.LEFT, 5)
        sizer_33.Add(self.button_5, 0, 0, 0)
        sizer_32.Add(sizer_33, 0, wx.EXPAND, 0)
        sizer_31.Add(sizer_32, 1, wx.EXPAND, 0)
        sizer_10.Add(sizer_31, 0, wx.EXPAND, 0)
        sizer_10.Add(self.button_6, 0, wx.LEFT, 5)
        sizer_9.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_9.Add(self.static_line_2, 0, wx.LEFT | wx.EXPAND, 20)
        sizer_41.Add(self.label_5, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_40.Add(sizer_41, 1, wx.ALIGN_RIGHT, 0)
        sizer_39.Add(sizer_40, 1, wx.EXPAND | wx.ALIGN_RIGHT, 0)
        sizer_39.Add(self.combo_box_1, 0, 0, 0)
        self.panel_3.SetSizer(sizer_39)
        sizer_14.Add(self.panel_3, 1, wx.EXPAND, 0)
        sizer_46.Add(self.label_11, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_45.Add(sizer_46, 1, wx.ALIGN_RIGHT, 0)
        sizer_42.Add(sizer_45, 1, wx.EXPAND, 0)
        sizer_42.Add(self.text_ctrl_1, 0, 0, 0)
        sizer_48.Add(self.label_12, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_47.Add(sizer_48, 1, wx.LEFT | wx.ALIGN_RIGHT, 10)
        sizer_42.Add(sizer_47, 1, wx.EXPAND, 0)
        sizer_42.Add(self.text_ctrl_5, 0, 0, 0)
        self.panel_1.SetSizer(sizer_42)
        sizer_15.Add(self.panel_1, 1, wx.ALIGN_RIGHT, 0)
        sizer_14.Add(sizer_15, 1, wx.EXPAND, 0)
        sizer_16.Add(self.button_7, 0, wx.LEFT, 45)
        sizer_14.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_13.Add(sizer_14, 0, wx.LEFT | wx.EXPAND, 0)
        sizer_17.Add(self.button_8, 0, 0, 0)
        sizer_17.Add(self.button_9, 0, 0, 0)
        sizer_13.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_9.Add(sizer_13, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_3.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_3.Add(self.static_line_1, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_20.Add(self.label_6, 0, wx.LEFT, 5)
        sizer_21.Add(self.button_10, 0, wx.LEFT, 5)
        sizer_21.Add(self.button_11, 0, 0, 0)
        sizer_20.Add(sizer_21, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_20, 0, wx.EXPAND, 0)
        sizer_22.Add(self.label_7, 0, 0, 0)
        sizer_23.Add(self.text_ctrl_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_23.Add(self.button_13, 0, 0, 0)
        sizer_22.Add(sizer_23, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_22, 0, wx.LEFT | wx.EXPAND, 20)
        sizer_18.Add(sizer_19, 0, wx.EXPAND, 0)
        sizer_11.Add(self.text_ctrl_3, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 0)
        sizer_25.Add(sizer_11, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_24.Add(sizer_25, 1, wx.EXPAND, 0)
        sizer_18.Add(sizer_24, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_18, 1, wx.TOP | wx.EXPAND, 5)
        sizer_2.Add(sizer_3, 1, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_28.Add(self.label_3, 0, 0, 0)
        sizer_28.Add(self.label_8, 0, 0, 0)
        sizer_28.Add(self.button_14, 0, 0, 0)
        sizer_27.Add(sizer_28, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_29.Add(self.label_4, 0, wx.LEFT, 20)
        sizer_35.Add(self.label_14, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_35.Add(self.button_4, 0, 0, 0)
        sizer_12.Add(sizer_35, 0, wx.EXPAND, 0)
        sizer_36.Add(self.label_15, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_36.Add(self.button_16, 0, 0, 0)
        sizer_12.Add(sizer_36, 0, wx.EXPAND, 0)
        sizer_34.Add(self.label_9, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_34.Add(self.button_15, 0, 0, 0)
        sizer_12.Add(sizer_34, 1, wx.LEFT | wx.EXPAND, 20)
        sizer_29.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_27.Add(sizer_29, 0, wx.LEFT | wx.EXPAND, 20)
        sizer_26.Add(sizer_27, 0, wx.EXPAND, 0)
        sizer_30.Add(self.label_2, 0, wx.LEFT, 5)
        sizer_30.Add(self.list_box_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_26.Add(sizer_30, 1, wx.EXPAND, 0)
        sizer_4.Add(sizer_26, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_8.Add(self.button_2, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_8.Add(self.button_3, 0, 0, 0)
        sizer_7.Add(sizer_8, 1, wx.TOP | wx.BOTTOM | wx.EXPAND, 10)
        sizer_5.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_6.Add(self.button_1, 0, wx.RIGHT | wx.TOP | wx.ALIGN_RIGHT, 10)
        sizer_5.Add(sizer_6, 1, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade
        self.setQstatLabel()
        sizer_1.Fit(self)
        self.Layout()


    #参照...(job選択)
    def onSelectJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.selectJob()

    #Job編集
    def onEditJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editJob()

    #設定file編集
    def onEditSettingFile(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editSettingFile()

    #設定
    def onSetQueueCpu(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setQueueCpu()

    #job投入実行
    def onRunJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runJob()

    #qstat -f
    def onQstat_f(self, event):  # wxGlade: MyFrame.<event_handler>
        self.qstat_f()

    #ganglia
    def onGanglia(self, event):  # wxGlade: MyFrame.<event_handler>
        self.ganglia()

    #その他コマンド
    def onRunCommand(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runCommand()

    #qstat
    def onQstat(self, event):  # wxGlade: MyFrame.<event_handler>
        self.qstat()

    #log表示
    def onShowLog(self, event):  # wxGlade: MyFrame.<event_handler>
        self.showLog()

    #plotWatcher起動
    def onPlotWatcher(self, event):  # wxGlade: MyFrame.<event_handler>
        self.plotWatcher()

    #qdel
    def onQdel(self, event):  # wxGlade: MyFrame.<event_handler>
        self.qdel()

    #folder開く
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openFolder()

    #login端末を開く
    def onRunTerminal(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runTerminal()

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    #
    #  subInitialize
    #
    def subInitialize(self):
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(paraEnvs)
        self.setCurrDir()

    #
    #  setCurrDir
    #    caseDirをlabelにセット
    def setCurrDir(self):
        currDir = caseDir
        maxChara = 55
        if len(currDir) > maxChara:
            currDir = "..." + currDir[len(currDir) - (maxChara - 3):]
        self.label_17.SetLabel(currDir)

    #
    #  setQstatLabel
    #    qstat実行時のtitle行を設定
    def setQstatLabel(self):
        titleLine = "job-ID  prior   name       user         state submit/start at     queue              "
        self.label_2.SetLabel(titleLine)

    #
    #  selectJob
    #    jobファイルの選択
    def selectJob(self):
        global jobFile, paraEnv, nCpu, selHost
        title = _(u"Jobファイルの選択")
        mess = _(u"編集するJobファイルを選択する。")
        fileFilter = "*"
        [stat, fileName] = getOpenFileDDialog.Show(title, mess, caseDir, fileFilter)
        if stat == "OK":
            jobFile = fileName
            self.text_ctrl_4.SetValue(jobFile)
            [paraEnv, nCpu, selHost] = readJobFile(fileName)
            self.setGEOption(paraEnv, nCpu, selHost)

    #
    #  setGEOption
    #    bactOptionをtextBoxに表示
    def setGEOption(self, paraEnv, nCpu, selHost):
        self.combo_box_1.SetStringSelection(paraEnv)
        self.text_ctrl_1.SetValue(nCpu)
        self.text_ctrl_5.SetValue(selHost)

    #
    #  editJob
    #    Jobファイルを編集
    def editJob(self):
        jobName = self.text_ctrl_4.GetValue()
        fileName = caseDir + "/" + jobName
        pyTreeFoam.runEditor(fileName)

    #  editSettingFile
    #    設定fileを編集
    def editSettingFile(self):
        global settingFilename
        path = os.getenv("TreeFoamUserPath") + "/data"
        fileName = path + "/gridEngine_data"
        pyTreeFoam.runEditor(fileName)

    #
    #  setQueueCpu
    #    batchのoptionを書き込む
    def setQueueCpu(self):
        job = self.text_ctrl_4.GetValue()
        paraEnv = self.combo_box_1.GetStringSelection()
        nCpu = self.text_ctrl_1.GetValue()
        selHost = self.text_ctrl_5.GetValue()
        [oFile, eFile] = getGEOutputLogFileNames()
        error = writeJobFile(job, paraEnv, nCpu, selHost, oFile, eFile)
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return
        title = _(u"Jobファイルの修正")
        mess = _(u"以下の内容を書き込みました。") + "\n\n"
        mess += ("  #$ -N " + job + "\n")
        if selHost == "":
            mess += ("  #$ -q all.q\n")
        else:
            mess += ("  #$ -q all.q@" + selHost + "\n")
        mess += ("  #$ -pe " + paraEnv + " " + nCpu + "\n")
        if oFile != "":
            mess += ("  #$ -o " + oFile + "\n")
        if eFile != "":
            mess += ("  #$ -e " + eFile + "\n")
        mess += ("  #$ -cwd\n")
        self.okDialog(title, mess)

    #
    #  runJob
    #    job投入
    def runJob(self):
        job = self.text_ctrl_4.GetValue()
        [paraEnv, nCpu, selHost] = readJobFile(job)
        error = ""
        if paraEnv == "":
            error = _(u"並列環境が設定されていません。")
        elif nCpu == "":
            error = _(u"並列数が設定されていません。")
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return

        title = _(u"Jobの投入")
        mess = _(u"以下の条件でJobを投入します。\n")
        mess += _(u"  並列環境: ") + paraEnv + "\n"
        mess += _(u"    並列数: ") + nCpu + "\n"
        if selHost != "":
            mess += _(u"    Host名: ") + selHost + "\n"
        stat = self.okCancelDialog(title, mess)
        if stat == "OK":
            #hostデータ読み込み
            data = pyTreeFoam.readSshfsData(serverName)
            hostDir = data[2]
            mountDir = data[3]
            login = data[4]
            #実行
            workDir = hostDir + caseDir[len(mountDir):]
            comm = "qsub " + job
            cont = runGECommandReturnCont(workDir, comm)
            #旧のjobIdを削除
            comm = "rm -rf " + caseDir + "/jobId:*"
            os.system(comm)
            #新しいjobId取得
            words = cont.split()
            for i in range(len(words)):
                word = words[i]
                if word == "job":
                    jobId = "jobId:" + words[i+1]
                    break
            fileName = caseDir + "/" + jobId
            f=open(fileName, "w"); f.write(job); f.close()
            #実行状況を表示
            title = _(u"Jobの投入")
            mess = _(u"Jobを投入しました。") + "\n\n"
            mess += cont.decode("utf-8")
            self.okDialog(title, mess)

    #
    #  qstat_f
    #    qstat -f を実行
    def qstat_f(self):
        comm = "qstat -f"
        cont = runGECommandReturnCont("~", comm)
        self.text_ctrl_3.SetValue(cont)

    #
    #  ganglia
    #
    def ganglia(self):
        address = "vector1.archi.gifu-nct.ac.jp/ganglia"
        comm = "firefox " + address + " &"
        os.system(comm)

    #
    #  runCommand
    #    コマンド実行
    def runCommand(self):
        data = pyTreeFoam.readSshfsData(serverName)
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        #実行
        workDir = hostDir + caseDir[len(mountDir):]
        comm = self.text_ctrl_2.GetValue()
        cont = runGECommandReturnCont(workDir, comm)
        #実行結果を表示
        self.text_ctrl_3.SetValue(cont)

    #
    #  qstat
    #    qstat実行
    def qstat(self):
        comm = "qstat"
        #cont = runGECommandReturnCont("~", comm)
        cont = runGECommandReturnStdout("~", comm)
        lines = cont.split("\n")[:-1]
        items = []
        for line in lines[2:]:
            items.append(line[:80])
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(items)

    #
    #  qdel
    #    job削除
    def qdel(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            title = _(u"エラー")
            mess = _(u"停止させるjobが選択されていません。")
            self.errDialog(title, mess)
            return
        title = _(u"jobの停止")
        mess = _(u"選択しているJobを停止させますか？")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        jobId = item.split()[0]
        comm = "qdel " + jobId
        cont = runGECommandReturnCont("~", comm)
        title = _(u"jobの停止")
        mess = _(u"以下のjobIdに対し、停止コマンド（qdel）を送出しました。") + "\n\n"
        mess += "jobId: " + jobId
        self.okDialog(title, mess)

    #
    #  showLog
    #    logの表示
    def showLog(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            title = _(u"エラー")
            mess = _(u"jobが選択されていません。")
            self.errDialog(title, mess)
            return
        else:
            jobId = item.split()[0]
            logFile = getLogFile(jobId)
            if logFile == "":
                title = _(u"エラー")
                mess = _(u"logFileが検出できませんでした。")
                self.errDialog(title, mess)
                return
        #setEnvironを作成
        foamTermSize = "110x24"
        data = pyTreeFoam.readSshfsData(serverName)
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        openDir = "/".join(logFile.split("/")[:-1])
        lines = setEnviron.split("\n")
        i = len(lines) - 1
        while i >= 0:
            if lines[i][:len("cd")] == "cd":
                words = lines[i].split()
                lines[i] = "cd " + openDir
                break
            i -= 1
        setEnviron = "\n".join(lines)
        #tmpFileを作成
        setEnviron += "tail -n 200 -f " + logFile + "\n"
        name = "setEnviron"
        fileName = os.getenv("TreeFoamUserPath") + "/temp/" + name
        f=open(fileName, "w"); f.write(setEnviron); f.close()
        #envファイルを転送
        pyTreeFoam.scpCommandNoTerm(fileName, "~", serverName)
        #login端末を起動
        pyTreeFoam.runLoginTerm(foamTermSize, serverName)

    #
    #  runTerminal
    #    login端末を開く
    def runTerminal(self):
        foamTermSize = "110x24"
        data = pyTreeFoam.readSshfsData(serverName)
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        if mountDir == "":
            setEnviron = ""
        else:
            if mountDir == caseDir[:len(mountDir)]:
                openDir = hostDir + caseDir[len(mountDir):]
                lines = setEnviron.split("\n")
                i = len(lines) - 1
                while i >= 0:
                    if lines[i][:len("cd")] == "cd":
                        words = lines[i].split()
                        lines[i] = "cd " + openDir
                        break
                    i -= 1
                setEnviron = "\n".join(lines)
            else:
                setEnviron = ""
        #tempFileを作成
        name = "setEnviron"
        fileName = os.getenv("TreeFoamUserPath") + "/temp/" + name
        f=open(fileName, "w"); f.write(setEnviron); f.close()
        #envファイルを転送
        pyTreeFoam.scpCommandNoTerm(fileName, "~", serverName)
        pyTreeFoam.runLoginTerm(foamTermSize, serverName)

    #
    #  openFolder
    #    folder開く
    def openFolder(self):
        pyTreeFoam.openFolderNautilus(caseDir)

    #
    #  plotWatcher
    #    plotWatcherを起動
    def plotWatcher(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            title = _(u"エラー")
            mess = _(u"jobが選択されていません。")
            self.errDialog(title, mess)
            return

        jobId = item.split()[0]
        logFile = getLogFile(jobId)
        if logFile == "":
            title = _(u"エラー")
            mess = _(u"logFileが検出できませんでした。")
            self.errDialog(title, mess)
            return

        #logFileをlocal側のpathに変換
        logFile = changeLocalPath(logFile)
        if logFile == "":
            title = _(u"エラー")
            mess = _(u"logFileが検出できません。") + "\n"
            return

        data = pyTreeFoam.readSshfsData(serverName)
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        #logFile = mountDir + logFile[len(hostDir):]
        #OpenFOAMの環境設定fileを取得
        configData = pyTreeFoam.readConfigTreeFoam()
        envOpenFOAMFix = configData[1]
        #caseDirを取得
        solveCase = "/".join(logFile.split("/")[:-1])
        #起動スクリプト作成
        cont = "#!/ban/bash\n"
        cont = cont + ". " + envOpenFOAMFix + "\n"
        cont = cont + 'echo -n "running plotWatcher"\n'
        cont = cont + "pyFoamPlotWatcher.py " + logFile + " 1> /dev/null 2> /dev/null\n"
        plotWatcher = solveCase + "/plotWatcher"
        f = open(plotWatcher, "w")
        f.write(cont)
        f.close()
        #plotWatcher実行
        os.system("chmod a+x " + plotWatcher)
        title = solveCase
        if len(title) > 30:
            title = "_..." + title[-30:]
        title = "plotWatcher:" + title
        comm = "gnome-terminal --name=" + title + " --geometry=80x2 --hide-menubar -x bash --rcfile " + plotWatcher
        os.system(comm)



    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame

#
#  changeLocalPath
#    server側のpathをlocal側のpathに変換
def changeLocalPath(serverPath):
    [allServer, mntNames] = pyTreeFoam.getAllServerNames()
    flag = 0; localPath = ""
    for mntName in mntNames:
        data = pyTreeFoam.readSshfsData(mntName)
        hostDir = data[2]
        mountDir = data[3]
        if serverPath[:len(hostDir)+1] == hostDir+"/":
            localPath = mountDir + serverPath[len(hostDir):]
            flag = 1
            break
    return localPath

#
#  getLogFile
#    logFileを探す
def getLogFile(jobId):
    data = pyTreeFoam.readSshfsData(serverName)
    hostDir = data[2]
    mountPoint = data[3]
    #jobIdのファイルを検索
    if type(jobId) == unicode:
        jobId = jobId.encode("utf-8")
    serverDir = hostDir + caseDir[len(mountPoint):]
    comm = "python ~/TreeFoamServer/bin/server_findJobFiles.py " + jobId + " " + serverDir
    comm += " #$"
    resultFile = "output"
    stat = pyTreeFoam.getTreeFoamServerSeparateResult(serverName, comm, resultFile)
    if stat != "OK":
        return ""

    #検索結果を取得
    fileName = os.getenv("TreeFoamUserPath") + "/temp/" + resultFile
    f=open(fileName); lines=f.readlines(); f.close()
    logFile = lines[0]
    return logFile

#
#  runGECommandReturnCont
#    GEコマンドを実行しその結果を返す
def runGECommandReturnCont(workDir, comm):
    data = pyTreeFoam.readSshfsData(serverName)
    login = data[4]
    sshHeader = data[6]
    #コマンド作成
    cont = "cd " + workDir + "; "
    cont += comm
    commLine = login + ' "' + cont + '"'
    print commLine
    commLine = sshHeader + commLine
    #コマンド実行
    result = runShellCommand(commLine)
    return result

#
#  runGECommandReturnStdout
#    GEコマンドを実行しその結果を返す
def runGECommandReturnStdout(workDir, comm):
    data = pyTreeFoam.readSshfsData(serverName)
    login = data[4]
    sshHeader = data[6]
    #コマンド作成
    cont = "cd " + workDir + "; "
    cont += comm
    commLine = login + ' "' + cont + '"'
    print commLine
    commLine = sshHeader + commLine
    #コマンド実行
    [stat, result, errResult] = pyTreeFoam.runShellCommandReturnSeparate(commLine)
    return result


#
#  readJobFile
#    jobFileの読み込み
def readJobFile(jobName):
    fileName = caseDir + "/" + jobName
    f = open(fileName); lines = f.readlines(); f.close()
    paraEnv = ""; nCpu = ""; selHost = ""
    for line in lines:
        if line[:len("#$ ")] == "#$ ":
            words = line.split()
            if len(words) > 1:
                if words[1] == "-pe":
                    paraEnv = words[2]
                    nCpu = words[3]
                elif words[1] == "-q":
                    hWords = words[2].split("@")
                    if len(hWords) == 2:
                        selHost = hWords[1]
    return [paraEnv, nCpu, selHost]

#
#  writeJobFile
#    jobFileに書き込み
def writeJobFile(job, paraEnv, nCpu, selHost, oFile, eFile):
    error = ""
    if job == "":
        error = _(u"Jobファイル名が設定されていません。")
        return error

    if paraEnv == "" or nCpu == "":
        error = _(u"並列環境、並列数が入力されていません。")
        return error

    jobFile = caseDir + "/" + job
    #ファイルが存在しない場合作成する
    if len(glob.glob(jobFile)) == 0:
        f = open(jobFile, "w"); f.write("#!/bin/bash\n"); f.close()
    #ファイルを読み込む
    f = open(jobFile); lines = f.readlines(); f.close()
    #関係する行を削除
    newLines = []
    for line in lines:
        if line[:len("#$ ")] != "#$ ":
            newLines.append(line)
    #追加する行を作成
    addLines = ["#$ -N " + job + "\n"]
    if selHost == "":
        addLines += ["#$ -q all.q\n"]
    else:
        addLines += ["#$ -q all.q@" + selHost + "\n"] 
    addLines += ["#$ -pe " + paraEnv + " " + nCpu + "\n"]
    addLines += ["#$ -o " + oFile + "\n"]
    if eFile != "":
        addLines += ["#$ -e " + eFile + "\n"]
    addLines += ["#$ -cwd\n"]
    #行を追加
    newLines = newLines[:1] + addLines + newLines[1:]
    #書き込み
    f = open(jobFile, "w")
    for line in newLines:
        f.write(line)
    f.close()
    return error

#
#  getGEOutputLogFileNames
#    logFile名を取得
def getGEOutputLogFileNames():
    fileName = os.getenv("TreeFoamUserPath") + "/data/gridEngine_data"
    f = open(fileName); lines = f.readlines(); f.close()
    logFileName = ""; errLogFileName = ""
    flag = [0, 0]
    for line in lines:
        words = line.split()
        if len(words) > 1:
            if words[0] == "logFileName":
                logFileName = words[1]
                flag[0] = 1
            elif words[0] == "errLogFileName":
                errLogFileName = words[1]
                flag[1] = 1
        if sum(flag) == 2:
            break
    return [logFileName, errLogFileName]    

#
#  initialize
#
def initialize():
    #gridEngine_dataファイル有無チェック
    userDir = os.getenv("TreeFoamUserPath") + "/data"
    userFileName = userDir + "/gridEngne_data"
    orgFileName = os.getenv("TreeFoamPath") + "/data/gridEngine_data"
    if len(glob.glob(userFileName)) == 0:
        comm = "cp " + orgFileName + " " + userDir
        os.system(comm)

#
#  runShellCommand
#    command実行
def runShellCommand(comm):
    result = ""
    try:
        result += subprocess.check_output(comm, stderr=subprocess.STDOUT, shell=True)
    except subprocess.CalledProcessError as e:
        result += e.output
    return result    



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    serverName = pyTreeFoam.getServerName(caseDir)
    initialize()
    #app = wx.PySimpleApp(0)
    #wx.InitAllImageHandlers()
    app = wx.App(0)
    frame_1 = MyFrame(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

