#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   pasteFromSystemClipBoar.py
#
#       systemClipBoardのfileを貼り付ける
#
#   15/06/24    新規作成
#   18/01/17    clipboard内のtypeを調べtypeに応じて処理を修正
#               cajaの場合、folderコピー時にtextとして保存されている為、これに対応。
#      01/18    clipboardの内容を判断し、nautilus(gnome)かcaja(mate)を決定し、folderを貼り付け
#               る様に修正。
#

import sys
import os
import pygtk
pygtk.require('2.0')
import gtk
import urllib

import logFileCreater; logFileCreater.log()

sysClipboard = gtk.clipboard_get()

#
#  pasteFromSystemClipBoard
#    clipboardからcopiedFilesを取得し、結果をfileに書き出す
def pasteFromSystemClipBoard(pasteContFile):
    #clipBoard呼び出し
    targets = sysClipboard.wait_for_targets()
    if targets != None:
        #clipboard内にdataがある場合
        copiedFiles = targets[3]
        if copiedFiles[:len("x-special")] == "x-special":
            #clipboardのdataがcopiedFileの場合
            selectiondata = sysClipboard.wait_for_contents(copiedFiles)
            lines = selectiondata.data.splitlines()
            action = lines[0].rstrip()
            uris = lines[1:]
            files = uris_to_paths(uris)
            #ファイルを貼り付け
            pasteFolders(pasteContFile, files)
            return
    #貼り付けるfolderがないのでclearする
    pasteFolders(pasteContFile, [])

#
#  uris_to_paths
#    URIをpathに変換
def uris_to_paths(uris):
    paths = []
    for uri in uris:
        if uri.startswith(u"file:/"):
            uri = uri[5:]
            while uri.startswith("//"):
                uri = uri[1:]
            paths.append(urllib.unquote(uri))
    return paths

#
#  pasteFolders
#    folderNameを書き込み
def pasteFolders(pasteContFile, files):
    #fileName = os.getenv("TreeFoamPath") + "/temp/pasteNames"
    fileName = pasteContFile
    f=open(fileName, "w")
    for name in files:
        f.write(name + "\n")
    f.close()



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    pasteContFile = sys.argv[1]
    pasteFromSystemClipBoard(pasteContFile)

